local addon, _raidtracker = ...
AddonName = "RaidTracker"

-- fix buff duration
-- fix flickering to "on cd"
--local RT = {}
local now = nil
local lastFrameTime = nil
local tmpAbs = {}
local needUpdate = true
local playerStatus = {}

_raidtracker.player_calling = nil

printf = Library.printf.printf

function Set (list)
  local set = {}
  for _, l in ipairs(list) do set[l] = true end
  return set
end

-- hold all frames ?
_raidtracker.frames = {}
-- hold categories frames
_raidtracker.frames.categories = {}
-- hold abilities frames
_raidtracker.frames.abilities = {}
_raidtracker.abilities = {}
_raidtracker.abilities.buff = {}
_raidtracker.buff = {}
_raidtracker.categories = {}

-- show or hidden options for sections
_raidtracker.categoriesOptions = {}
-- last update timestamp by player id.
_raidtracker.lastUpdateByPlayerId = {}
-- obsolete
_raidtracker.playerLastTier = nil
-- config window
_raidtracker.configWindow = nil
-- hold base frames
_raidtracker.baseFrame = {}
-- translation for sections
_raidtracker.translation = {}
_raidtracker.translation["battleRes"] = "Battle Resurect"
_raidtracker.translation["massCleanse"] = "AOE Cleanse"
_raidtracker.translation["wildGrowth"] = "Wild Growth"
_raidtracker.translation["raidHealingBurst"] = "Raid Healing Burst"
_raidtracker.translation["lavaField"] = "Lava Field"
_raidtracker.translation["flaringPower"] = "Flaring Power"
_raidtracker.translation["focusFire"] = "Focus Fire"
_raidtracker.translation["manaRegen"] = "Mana Regen"
_raidtracker.translation["tools"] = "Tools"
_raidtracker.translation["interrupt"] = "Interrupt"
-- list abilities being tracked
_raidtracker.abilities.all = {}
_raidtracker.abilities.definition = {}
_raidtracker.units = {}
_raidtracker.abilities.tracking = {}
_raidtracker.buff.tracking = {}
_raidtracker.abilities.namesToId = {}
_raidtracker.abilities.registered = {}


-- default color settings
_raidtracker.default = {
	colors = {
		category = {
			active = {
				background = {0.8, 0.2, 0, 0.7},
				},
			inactive = {
				background = {0.5, 0.5, 0.5, 0.7},
				},
			},
		ability = {
			ready = {
				background = {0,0.7,0,0.7},
				},
			cooldown = {
				background = {1,1,0,0.7},
				},
			dead = {
				background = {0.5,0.5,0.5,0.7},
			},
			active = {
				background = {0.0,0.5,1,0.7},
			}
		}
	}
}


function _raidtracker.trackAbility(category, abilities)
	_raidtracker.abilities.all[category] = abilities
end

function _raidtracker.translate(txt) 
	if _raidtracker.translation[txt] ~= nil then
		return _raidtracker.translation[txt]
	end
	return txt
end

_raidtracker.trackAbility("battleRes", {
	A2942FF34A490A22D = true, -- River of Life
	A74C19819577CEA4D = true, -- Flash of the Phoenix
	A4D4EFA27574FDC9A = true, -- Absolution
	A26862464D9EECBE7 = true, -- Life's Return
	AFDD327BDD0828E57 = true, -- Death's Embrace
	A4AE33670A72C0F45 = true, -- Soul Tether
	A5F5BA8A108A5111A = true, -- Soul Redemption
	A72E5E73166B95DD1 = true -- Kiss of Life
})
_raidtracker.trackAbility("massCleanse" ,{
	AFE53E2190E6923B7 = true, -- Cleansing Rush/chloro
	A2965343D52D98AB6 = true, -- Cauterizing Wave/purifier
	A21A904886D7EA283 = true, -- Counteract/liberator
	A20E068C2C0CD89F9 = true, -- mass detox/physician
	A1E4E7DBB72466C42 = true, -- empowering light/senti
	A00E6951C7C1781EC = true, -- Curative Waters/warden
	A5F14D3FF39C8C2C9 = true, -- Cleansing Chant/oracle
	A1ECF64B4A1A97DFF = true, -- Verse of Purity/barde
})
_raidtracker.trackAbility("raidHealingBurst", {
	A483A8B14922C2865 = {buffId = b80000004739468A7, duration=6, unit="caster"}, --	Life's Rapture/paladin
	AFABF9CC466A13DEE = {buffID = b80000002649EAE3B, duration=6, unit="caster"}, --	Flame of Life/puri
	AFD00EEA28FF099C9 = {buffId = b8000000473947C1A, duration=30, unit="caster"}, -- Command to Recover/beasmtmaster
	AFE2FD850D13CEABE = {buffId = b8000000473947C7F, duration=30, unit="caster"}, -- Command to Stand Ground/beastmaster
})



_raidtracker.trackAbility("wildGrowth", {
	A1228F93DC7326968 = {duration = 12, unit = "caster", buffId = "B087BE1DF34A67269", cooldown = 60}, -- wild growth/chloromancer
	AFBF79829B2DD89A0 = {buffId = b80000002649EBEFE, duration=15, unit="caster"}, -- Power Core/tactician
})
_raidtracker.trackAbility("lavaField", {
	A2303677658E3BEFD = {duration = 10, cooldown = 60, buffId = "B14A2E6D509F79153"}, -- lava field/archon
	AFFA7EFCDAA9506A3 = {buffId = b80000000C0768607, duration=10, unit="caster"}, -- Enrage/beastmaster
	AFAA9C085A3AD3A8E = {buffId = b80000002649EC2BF, duration=15, unit="caster"}, -- Orchestra of the Planes/barde
	A2BBE0D93CAE15935 = {buffId = b80000002649EA443, duration=15, unit="caster"}, -- Defend the Fallen/oracle
})
_raidtracker.trackAbility("flaringPower", {
	A67D9C8E34456AC35 = {duration = 30, unit = "caster", buffId = "B2F55F12AF5DA3E23", cooldown = 120}, -- flaring power/archon
	AFAEE513B677B63D2 = {buffID = b8000000473947BE2, unit="caster", duration=30}, -- Command to Attack/beastmaster
})
_raidtracker.trackAbility("focusFire", {
	AFD663483C3050AAF = {duration = 15, cooldown = 30, buffId=b80000004739525D7, unit="caster"}, --	Focused Fire/tempest
})
_raidtracker.trackAbility("manaRegen", {
	A2DAD149799991550 = {buffId = b80000002649EC2E3, unit="caster", duration=15}, --	Verse of Joy/barde
	A3B0C08974A8812D2 = {buffId = b80000002649E898F, unit="caster", duration=15}, --	Resuscitating Chant
})


_raidtracker.trackAbility("tools", {
	A29A16B1598BD6291 = {buffId = "B17FCD4C21F9BC5D2", unit="caster", cooldown = 30}, --Reflective Presence/domi/aoe reflect
	A76828EB12F614011 = {duration = 10, unit = "target", buffId = "B2C2BF22449432CD9", cooldown = 10}, --Reflective Command/domi/reflect
	A2ED0D1AD728617AE = true, --Arresting Presence/domi/aoe silence
	A17DEC19F957D35ED = {duration = 6, unit = "target", buffId = "B7CAB6ACA77E37807", cooldown = 30}, --Mana Wrench/domi /mana leech
	A1F6019C067CD574C = true, -- Transference/domi /mana leech
	A0A57803A6011387D = {buffId = "b8000000551F9ABF7", duration =8, unit = "target", cooldown = 30}, -- Burning Bonds/pyro / root
	A5C085E84888EE174 = true, --	Static Shot/marksman/root
	A763B186D6A4F7852 = true, --	Sterilize/purifier/full cleanse
})


_raidtracker.trackAbility("purge", {
	A23C4DF80B99E4528 = true, -- Degeneration/domi/purge
	AFD7025D154FB9967 = true, -- Spell Destruction/void knight aoe purge
	A761E0FF2A95D81BF = true, -- Spell Sunder/void knight/purge
	A2EFCA11B39984648 = true, -- Eradicate/marksman/purge
	A7A6C1064540AEAE0 = true, -- purge/inquisiteur/purge
})

_raidtracker.trackAbility("interrupt", {
	A17CA4E11966D37C9 = true, -- Thunder Blast/dominator
	A731E97D4949C18A9 = true, -- Scorch/pryo
	A032A0A457CC7F621 = true, -- Distracting Slash/harbinger
	A1E4A0C607A4CD62D = true, -- Freezing Gust/arbitrer
	A114D0B26C789A345 = true, -- Flinching Strike/paragon
	A5BF74A176BE8056A = true, -- Face Slam/paladin
	A5900336E981E3D9F = true, -- Furious Rage/void knight
	AFCF4FD125D747074 = true, -- Distracting Pulse/tempest
	AFC001ACAA88C1DFC = true, -- Spasm/reaver
	A0FD7EFA854E498A5 = true, -- Planar Disruption/rift stalker
	A1E9ECBA0C5E7B037 = true, -- Deaden/marksman
	A7403BBCFAF89FCAB = true, -- Interdict/justicar
	A2388637170F9C0F6 = true, -- Bitter Wind/shaman
	A77F0EA9A9758B569 = true, -- confound/inquisitor
	A4EDAD6AA6FC94EE4 = true, -- notion theft/druid
	A73723C02BF6828CF = true, -- stonespear/rift blade
	A3DC82AAEAEB2F5B3 = true, -- weapon barrage/bladeancer
	A073F3DFFEF67CBE0 = true, -- concussive blast/ranger
})

for category, abs in pairs(_raidtracker.abilities.all) do
	for k,ab in pairs(abs) do
		_raidtracker.abilities.tracking[k] = category
		_raidtracker.abilities.definition[k] = ab
		if ab ~= true then
			ab.buffId = ab.buffId or category .. "#" .. k
			ab.abilityId = k
			_raidtracker.abilities.buff[k] = ab.buffId

			_raidtracker.buff.tracking[ab.buffId] = ab
		end
	end
end
local tmpIds = {}
for k,v in pairs(_raidtracker.abilities.tracking) do table.insert(tmpIds, k) end
for k,ab in pairs(Inspect.Ability.New.Detail(tmpIds)) do
	_raidtracker.abilities.namesToId[ab.name] = ab.id
end

-- form player.id = { ability.id = {abilityType = "cleanse/res...", cd = x, useTime = x, frame = x}, ...}

function _raidtracker.isCasterAlive(id)
	if playerStatus[id] == nil then return true end
	return playerStatus[id].alive
end

function _raidtracker.wasCasterAlive(id)
	if playerStatus[id] == nil then return true end
	return playerStatus[id].aliveBefore
end

function _raidtracker.GetBroadcastType()
	group = {"group01","group02","group03","group04","group05"}
	raid = {"group06","group07","group08","group09","group10","group11","group12","group13","group14","group15","group16","group17","group18","group19","group20",}
	if next(Inspect.Unit.Lookup(raid)) then
		return "raid"
	elseif next(Inspect.Unit.Lookup(group)) then
		return "party"
	else
		return nil
	end
end
function _raidtracker.split(inputstr, sep)
    if sep == nil then
        sep = "%s"
    end
    local t={} ; i=1
    for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
        t[i] = str
        i = i + 1
    end
    return t
end

function _raidtracker.round(num, idp)
	return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

function _raidtracker.createConfigBlock(category, abilities)
	local w = _raidtracker.configWindow
	local block = UI.CreateFrame("Frame", "category block " .. category, w.skillsConfig)
	block:SetWidth(850)
	local tmpAb = nil
	local rowCnt = 0
	local cnt = 0
	local lastElement = nil
	local ce = nil
	block.abilities = {}

	if w.lastElement == nil then
		block:SetPoint("TOPLEFT", w.skillsConfig, "TOPLEFT", 15, 40)
	else
		block:SetPoint("TOPLEFT", w.lastElement, "BOTTOMLEFT", 0, 15)
	end
	w.lastElement = block
	--block:SetBackgroundColor(0.5,0.5,0.5,0.5)

	block.categoryCheckBox = UI.CreateFrame("RiftCheckbox", "category block checkbox", block)
	local bcc = block.categoryCheckBox

	block.category = UI.CreateFrame("Text", "category block text", block)
	local bc = block.category

	w.blocks[category] = block
	if _raidtracker_tracking["categories"][category] == nil then _raidtracker_tracking["categories"][category] = true end
	bcc:SetChecked(_raidtracker_tracking["categories"][category])
	bcc:SetPoint("TOPLEFT", block, "TOPLEFT", 5, 5)

	bc:SetPoint("CENTERLEFT", bcc, "CENTERRIGHT", 5, 0)
	bc:SetText(_raidtracker.translate(category))
	bc:SetFontSize(25)

	for k,v in pairs(abilities) do
		block.abilities[k] = UI.CreateFrame("Text", "ability text", block)
		ce = block.abilities[k]
		tmpAb = Inspect.Ability.New.Detail(k)
		ce:SetText(tmpAb.name)
		ce:SetFontSize(13)
		
		if _raidtracker_tracking["abilities"] == nil then 
			_raidtracker_tracking["abilities"] = {} 
		end
		if _raidtracker_tracking["abilities"][k] == nil then 
			_raidtracker_tracking["abilities"][k] = true 
		end
		if _raidtracker_tracking["abilities"][k] == true then
			ce:SetFontColor(1,1,1)
		else
			ce:SetFontColor(1,0,0)
		end
		if cnt == 5 then
			cnt = 0
			rowCnt = rowCnt + 1
		end
		ce:SetPoint("TOPLEFT", block, "TOPLEFT", 15 + cnt * 180, rowCnt * 20 + 35)
		cnt = cnt + 1
		lastElement = ce

		ce.icon = UI.CreateFrame("Texture", "icon", ce)
		ce.icon:SetTexture("Rift", tmpAb.icon)
		ce.icon:SetPoint("TOPRIGHT", ce, "TOPLEFT", -3, 0)
		ce.icon:SetWidth(19)
		ce.icon:SetHeight(19)
		ce.icon.text = ce

		ce.icon:EventAttach(Event.UI.Input.Mouse.Left.Click, function(e) 
			if e.text._raidtracker_trackingEnabled then 
				_raidtracker_tracking["abilities"][v] = false
				e.text:SetFontColor(1,0,0)
				e.text._raidtracker_trackingEnabled = false
			else 
				_raidtracker_tracking["abilities"][v] = true
				e.text._raidtracker_trackingEnabled = true
				e.text:SetFontColor(1,1,1)
			end 
			needUpdate = true
		end, "clickblabla")
	end


	bcc:EventAttach(Event.UI.Checkbox.Change, function(e) 
			needUpdate = true
			if bcc:GetChecked() then 
				bc:SetFontColor(1,1,1,1) 
				for k,v in pairs(block.abilities) do 
					v:SetFontColor(1,1,1,1) 
					v._raidtracker_trackingEnabled = true
					_raidtracker_tracking["categories"][category] = true
				end
				for k,v in pairs(_raidtracker.abilities.all[category]) do
					_raidtracker_tracking["abilities"][v] = true
				end
			else
				bc:SetFontColor(1,0.2,0,1) 
				for k,v in pairs(block.abilities) do 
					v:SetFontColor(1,0.2,0,1) 
					v._raidtracker_trackingEnabled = false
					_raidtracker_tracking["categories"][category] = false
				end 
				for k,v in pairs(_raidtracker.abilities.all[category]) do
					_raidtracker_tracking["abilities"][v] = false
				end
			end 
			_raidtracker.UpdatePlayerAbilities()
		end, "blabla")

	block:SetHeight(50 + rowCnt * 20)
end
function _raidtracker.updatePreview(frame)
	local f = _raidtracker.configWindow.colorConfig
	local red = f.redSlider:GetPosition() / 255
	local green = f.greenSlider:GetPosition() / 255
	local blue = f.blueSlider:GetPosition() / 255
	local alpha = f.alphaSlider:GetPosition() / 100
	f.result:SetBackgroundColor(red, green, blue, alpha)
	local index = f.select:GetSelectedIndex()

	if index == 1 then
		_raidtracker_color.category.active.background = {red, green, blue, alpha}
	elseif index == 2 then
		_raidtracker_color.category.inactive.background = {red, green, blue, alpha}
	elseif index == 3 then
		_raidtracker_color.ability.cooldown.background = {red, green, blue, alpha}
	elseif index == 4 then
		_raidtracker_color.ability.ready.background = {red, green, blue, alpha}
	elseif index == 5 then
		_raidtracker_color.ability.dead.background = {red, green, blue, alpha}
	elseif index == 6 then
		_raidtracker_color.ability.active.background = {red, green, blue, alpha}
	end
end

function _raidtracker.changeConfigCategoryBaseFrame(view, item, value, index)
	_raidtracker_baseFrames.categories[view.category] = tonumber(index)
	needUpdate = true
end

function _raidtracker.setupBaseFrameConfigFrame(frame)
	local tmpFrame = UI.CreateFrame("Frame", "background frame", frame)
	tmpFrame:SetWidth(600)
	tmpFrame:SetHeight(450)
	tmpFrame:SetBackgroundColor(0.3,0.3,0.3,0.5)
	tmpFrame:SetLayer(0)
	tmpFrame:SetPoint("TOPCENTER", frame, "TOPCENTER", -10, 10)

	frame.baseFrameCountText = UI.CreateFrame("Text", "base frame count text", tmpFrame)
	local bfct = frame.baseFrameCountText
	bfct:SetLayer(1)
	bfct:SetText("Base Frame Count : ")
	bfct:SetPoint("TOPCENTER", tmpFrame, "TOPCENTER", -190, 5)
	frame.baseFrameCount = UI.CreateFrame("RiftSlider", "base frame count", tmpFrame)
	local bfc = frame.baseFrameCount
	bfc:SetLayer(1)
	frame.baseFrameCount.parent = frame
	frame.baseFrameCountIndicator = UI.CreateFrame("Text", "indicator", tmpFrame)
	local bfci = frame.baseFrameCountIndicator
	bfci:SetBackgroundColor(0, 0, 0)
	bfci:SetWidth(30)
	bfci:SetHeight(20)
	bfci:SetFontColor(1,1,1)
	bfci:SetLayer(1)
	bfci:SetPoint("CENTERLEFT", bfc, "TOPRIGHT", 15, 5)

	bfc:SetRange(1,5)
	bfc:SetPosition(_raidtracker_baseFrames.count)
	frame.baseFrameCountIndicator:SetText(tostring(_raidtracker_baseFrames.count))
	bfc:SetPoint("TOPLEFT", bfct, "CENTERRIGHT", 15, -5)

	frame.categories = {}
	local itemList = {}
	local valueList = {}
	for i=1,_raidtracker_baseFrames.count,1 do 
		table.insert(itemList, tostring(i))
		table.insert(valueList, i)
	end

	frame.infoCat = UI.CreateFrame("Text", "info cat", frame)
	frame.infoCat:SetPoint("TOPCENTER", bfc, "BOTTOMCENTER", 0, 0)
	frame.infoCat:SetText("In the following section you can affect a category to a basic frame to sort your frames suiting your liking.")

	i = 1
	for category, abs in pairs(_raidtracker.abilities.all) do
		frame.categories[i] = UI.CreateFrame("Text", category, tmpFrame)
		frame.categories[i]:SetText(_raidtracker.translate(category) .. " : ")
		frame.categories[i]:SetPoint("TOPLEFT", bfct, "BOTTOMRIGHT", 0, 40 + (i - 1) * 30)
		frame.categories[i].select = UI.CreateFrame("SimpleSelect", category .. " select", tmpFrame)
		frame.categories[i].select:SetPoint("TOPLEFT", frame.categories[i], "TOPLEFT", 200, 0)
		frame.categories[i].select:SetLayer(1)
		frame.categories[i].select.category = category
		frame.categories[i].select:SetItems(itemList, valueList)
		frame.categories[i]:SetLayer(1)
		frame.categories[i].select:SetSelectedIndex(_raidtracker_baseFrames.categories[category])
		frame.categories[i].select.Event.ItemSelect = _raidtracker.changeConfigCategoryBaseFrame
		i = i + 1
	end

	frame.baseFrameCount:EventAttach(Event.UI.Slider.Change, 
		function(self) 
				_raidtracker_baseFrames.count = self:GetPosition() 
				frame.baseFrameCountIndicator:SetText(tostring(_raidtracker_baseFrames.count))
				local itemList = {}
				local valueList = {}
				for i=1,_raidtracker_baseFrames.count,1 do 
					table.insert(itemList, tostring(i))
					table.insert(valueList, i)
				end
				for k,v in pairs(self.parent.categories) do
					v.select:SetItems(itemList, valueList)
					v.select:SetSelectedIndex(_raidtracker_baseFrames.categories[v.select.category])
					if v.select:GetSelectedIndex() == nil or v.select:GetSelectedIndex() > _raidtracker_baseFrames.count then
						v.select:SetSelectedIndex(1)
					end
				end
				for i=1,5,1 do
					if i <= _raidtracker_baseFrames.count then
						if _raidtracker.baseFrame[i] == nil then
							_raidtracker.setupBaseFrame(i)
						else
							_raidtracker.baseFrame[i]:SetVisible(true)
						end
					end
					if i > _raidtracker_baseFrames.count and _raidtracker.baseFrame[i] ~= nil then
						_raidtracker.baseFrame[i]:SetVisible(false)
					end
				end
				needUpdate = true
			end, 
		"slider change")

	frame.infoDir = UI.CreateFrame("Text", "info dir", tmpFrame)
	frame.infoDir:SetPoint("TOPLEFT", bfct, "BOTTOMRIGHT", -100, 15 + (i) * 30)
	frame.infoDir:SetText("In the following section you can change the direction in which the bars will be positioned.")
	frame.directionText = UI.CreateFrame("Text", "direction", tmpFrame)
	frame.directionText:SetText("Direction : ")
	frame.directionText:SetFontSize(20)
	frame.directionText:SetPoint("TOPLEFT", bfct, "BOTTOMRIGHT", -100, (i + 1) * 30)
 
	frame.directionChoice = Library.LibSimpleWidgets.RadioButtonGroup("direction")
	local dc = frame.directionChoice
	dc.Event.RadioButtonChange = function(self)
      _raidtracker_baseFrames.direction = self:GetSelectedRadioButton().direction
      needUpdate = true
    end
	dc.directionTop = UI.CreateFrame("SimpleRadioButton", "direction top", tmpFrame)
	dc.directionTop:SetText("Top")
	dc.directionTop.direction = "top"
	dc.directionTop:SetPoint("CENTERLEFT", frame.directionText, "CENTERRIGHT", 30, 0)
	dc.directionBot = UI.CreateFrame("SimpleRadioButton", "direction top", tmpFrame)
	dc.directionBot:SetText("Bot")
	dc.directionBot.direction = "bot"
	dc.directionBot:SetPoint("TOPLEFT", dc.directionTop, "TOPRIGHT", 15, 0)
	dc:AddRadioButton(dc.directionTop)
	dc:AddRadioButton(dc.directionBot)

	if _raidtracker_baseFrames.direction == "top" then
		frame.directionChoice:SetSelectedIndex(1, true)
	else
		frame.directionChoice:SetSelectedIndex(2, true)
	end
end

function _raidtracker.setupColorConfigFrame(frame)
	-- select
	local tmpFrame = UI.CreateFrame("Frame", "background frame", frame)
	tmpFrame:SetWidth(600)
	tmpFrame:SetHeight(350)
	tmpFrame:SetBackgroundColor(0.3,0.3,0.3,0.5)
	tmpFrame:SetLayer(0)
	tmpFrame:SetPoint("TOPCENTER", frame, "TOPCENTER", -10, 10)
	frame.select = UI.CreateFrame("SimpleSelect", "select", tmpFrame)
	local s = frame.select
	s:SetWidth(300)
	s:SetPoint("TOPCENTER", tmpFrame, "TOPCENTER", 0, 20)
	s:SetLayer(1)
	local strList = {
		"Category (visible) Background ",
		"Category (hidden) Background ",
		"Cooldown Bar (on cooldown) Background ",
		"Cooldown Bar (ready) Background ",
		"Cooldown Bar (dead caster) Background ",
		"Cooldown Bar (active) Background ",
		}
	local valueList = {
		_raidtracker_color.category.active.background, 
		_raidtracker_color.category.inactive.background, 
		_raidtracker_color.ability.cooldown.background, 
		_raidtracker_color.ability.ready.background, 
		_raidtracker_color.ability.dead.background, 
		_raidtracker_color.ability.active.background}
	s:SetItems(strList, valueList)

	--**ItemSelect(item, value, index)** 

	-- sliders
	frame.redSliderText = UI.CreateFrame("Text", "red slider text", tmpFrame)
	frame.redSliderText:SetPoint("TOPRIGHT", frame, "TOPCENTER", -200, 60)
	frame.redSliderText:SetText("Red : ")
	frame.redSliderText:SetWidth(100)
	frame.redSliderText:SetLayer(1)
	frame.redSlider = UI.CreateFrame("RiftSlider", "red slider", tmpFrame)
	local rs = frame.redSlider
	rs:SetLayer(1)
	frame.redSlider:EventAttach(Event.UI.Slider.Change, _raidtracker.updatePreview, "red")
	rs:SetRange(0,255)
	rs:SetPoint("TOPLEFT", frame.redSliderText, "TOPRIGHT", 15, 0)


	frame.greenSliderText = UI.CreateFrame("Text", "green slider text", tmpFrame)
	frame.greenSliderText:SetPoint("TOPRIGHT", frame, "TOPCENTER", -200, 90)
	frame.greenSliderText:SetText("Green : ")
	frame.greenSliderText:SetWidth(100)
	frame.greenSliderText:SetLayer(1)
	frame.greenSlider = UI.CreateFrame("RiftSlider", "green slider", tmpFrame)
	local rg = frame.greenSlider
	rg:SetLayer(1)
	frame.greenSlider:EventAttach(Event.UI.Slider.Change, _raidtracker.updatePreview, "preview green")
	rg:SetRange(0,255)
	rg:SetPoint("TOPLEFT", frame.greenSliderText, "TOPRIGHT", 15, 0)


	frame.blueSliderText = UI.CreateFrame("Text", "blue slider text", tmpFrame)
	frame.blueSliderText:SetPoint("TOPRIGHT", frame, "TOPCENTER", -200, 120)
	frame.blueSliderText:SetText("Blue : ")
	frame.blueSliderText:SetWidth(100)
	frame.blueSliderText:SetLayer(1)
	frame.blueSlider = UI.CreateFrame("RiftSlider", "blue slider", tmpFrame)
	local rb = frame.blueSlider
	rb:SetLayer(1)
	frame.blueSlider:EventAttach(Event.UI.Slider.Change, _raidtracker.updatePreview, "preview blue")
	rb:SetRange(0,255)
	rb:SetPoint("TOPLEFT", frame.blueSliderText, "TOPRIGHT", 15, 0)




	frame.alphaSliderText = UI.CreateFrame("Text", "alpha slider text", tmpFrame)
	frame.alphaSliderText:SetPoint("TOPRIGHT", frame, "TOPCENTER", -200, 150)
	frame.alphaSliderText:SetText("Alpha : ")
	frame.alphaSliderText:SetWidth(100)
	frame.alphaSliderText:SetLayer(1)
	frame.alphaSlider = UI.CreateFrame("RiftSlider", "alpha slider", tmpFrame)
	local as = frame.alphaSlider
	as:SetLayer(1)
	frame.alphaSlider:EventAttach(Event.UI.Slider.Change, _raidtracker.updatePreview, "preview alpha")
	as:SetRange(0,100)
	as:SetPoint("TOPLEFT", frame.alphaSliderText, "TOPRIGHT", 15, 0)

	-- result
	frame.result = UI.CreateFrame("Frame", "result frame", tmpFrame)
	frame.result:SetLayer(1)
	frame.result:SetWidth(200)
	frame.result:SetHeight(80)
	frame.result:SetBackgroundColor(0,0,0)
	frame.result:SetPoint("TOPLEFT", frame.redSlider, "TOPRIGHT", 10, 0)
	-- save
	frame.saveButton = UI.CreateFrame("RiftButton", "save button", tmpFrame)
	frame.saveButton:SetLayer(1)
	frame.saveButton:SetText("Apply")
	frame.saveButton:SetPoint("TOPRIGHT", frame, "TOPCENTER", -50, 180)
	frame.saveButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function() needUpdate = true end, "save")
	-- reset
	frame.resetButton = UI.CreateFrame("RiftButton", "Reset button", tmpFrame)
	frame.resetButton:SetLayer(1)
	frame.resetButton:SetText("Reset")
	frame.resetButton:SetPoint("TOPLEFT", frame, "TOPCENTER", 50, 180)


	s.Event.ItemSelect = function(view, item, value, index) 
		rs:SetPosition(math.floor(value[1] * 255))
		rg:SetPosition(math.floor(value[2] * 255))
		rb:SetPosition(math.floor(value[3] * 255))
		if value[4]  == nil then
			value[4] = 1
		end
		as:SetPosition(math.floor(value[4] * 100))
	end

	frame.widthText = UI.CreateFrame("Text", "width text", tmpFrame)
	frame.widthText:SetPoint("TOPLEFT", frame.saveButton, "BOTTOMLEFT", 0, 20)
	frame.widthText:SetText("Bar width : ")

	frame.width = UI.CreateFrame("SimpleSlider", "width", tmpFrame)
	frame.width:SetRange(100,500)
	frame.width:SetPoint("TOPLEFT", frame.widthText, "TOPRIGHT", 15, 0)
	if _raidtracker_baseFrames.width == nil then
		_raidtracker_baseFrames.width = 200
	end
	frame.width:SetEditable(true)
	frame.width:SetPosition(_raidtracker_baseFrames.width)
	frame.width.Event.SliderRelease = function(e) 
		_raidtracker_baseFrames.width = e:GetPosition()
		for i,b in pairs(_raidtracker.baseFrame) do b:SetWidth(_raidtracker_baseFrames.width) end
		for i,b in pairs(_raidtracker.frames.categories) do b:SetWidth(_raidtracker_baseFrames.width) end
		for i,b in pairs(_raidtracker.frames.abilities) do 
			b:SetWidth(_raidtracker_baseFrames.width)
			b.texture:SetWidth(_raidtracker_baseFrames.width - 27)
		end
		needUpdate = true
	end



	frame.fontSizeText = UI.CreateFrame("Text", "width text", tmpFrame)
	frame.fontSizeText:SetPoint("TOPLEFT", frame.widthText, "BOTTOMLEFT", 0, 20)
	frame.fontSizeText:SetText("font size : ")

	frame.fontSize = UI.CreateFrame("SimpleSlider", "fontSize", tmpFrame)
	frame.fontSize:SetRange(10,30)
	frame.fontSize:SetPoint("TOPLEFT", frame.fontSizeText, "TOPRIGHT", 15, 0)
	if _raidtracker_baseFrames.fontSize == nil then
		_raidtracker_baseFrames.fontSize = 15
	end
	frame.fontSize:SetEditable(true)
	frame.fontSize:SetPosition(_raidtracker_baseFrames.fontSize)
	frame.fontSize.Event.SliderRelease = function(e) 
		_raidtracker_baseFrames.fontSize = e:GetPosition()
		for i,b in pairs(_raidtracker.frames.categories) do b.text:SetFontSize(_raidtracker_baseFrames.fontSize) end
		for i,b in pairs(_raidtracker.frames.abilities) do 
			b.player:SetFontSize(_raidtracker_baseFrames.fontSize)
			b.cdText:SetFontSize(_raidtracker_baseFrames.fontSize)
		end
		needUpdate = true
	end
end

function _raidtracker.setupConfigWindow()
	if _raidtracker.configWindow ~= nil then return end
	_raidtracker.configWindow = UI.CreateFrame("SimpleWindow", "config window", _raidtracker.context)
	local w = _raidtracker.configWindow
	w:SetPoint("CENTER", UIParent, "CENTER")
	w.closeButton = UI.CreateFrame("RiftButton", "close button", w)
	w.closeButton:EventAttach(Event.UI.Input.Mouse.Left.Click, 
		function() 
			w:SetVisible(false) 
			for i,frame in pairs(_raidtracker.baseFrame) do
				frame:SetVisible(false)
			end
		end, "CloseConfigWindow")
	w.closeButton:SetText("Close")
	w.closeButton:SetPoint("BOTTOMRIGHT", w, "BOTTOMRIGHT", -15, -15)
	w:SetHeight(1000)
	w:SetWidth(900)
	w:SetLayer(99)
	w.lastElement = nil
	w.abilities = {}
	w.blocks = {}

	w.tabView = UI.CreateFrame("SimpleTabView", "tab view", w)
	w.tabView:SetHeight(900)
	w.tabView:SetWidth(870)
	w.tabView:SetPoint("TOPLEFT", w, "TOPLEFT", 15, 60)
	w.tabView:SetTabPosition("top")

	w.skillsConfig = UI.CreateFrame("Frame", "skillconfig frame", w.tabView)
	w.tabView:AddTab("_raidtracker_tracking", w.skillsConfig)

	w.colorConfig = UI.CreateFrame("Frame", "color config frame", w.tabView)
	w.tabView:AddTab("Colors & size", w.colorConfig)

	w.baseFrameConfig = UI.CreateFrame("Frame", "base frame config frame", w.tabView)
	w.tabView:AddTab("Arrangement", w.baseFrameConfig)

	_raidtracker.setupColorConfigFrame(w.colorConfig)
	_raidtracker.setupBaseFrameConfigFrame(w.baseFrameConfig)

	w:SetTitle("Raid Tracker :: Configuration")

	w.skillsConfig.info = UI.CreateFrame("Text", "info category", w.skillsConfig)
	w.skillsConfig.info:SetPoint("TOPLEFT", w.skillsConfig, "TOPLEFT", 5, 5)
	w.skillsConfig.info:SetText("You can choose to disable categories, they'll still be tracked and shared with other people but they won't be displayed for you.")

	for category, abilities in pairs(_raidtracker.abilities.all) do
		_raidtracker.createConfigBlock(category, abilities)
	end

	w:SetVisible(false)
end

function _raidtracker.showConfig()
	_raidtracker.setupConfigWindow()
	if _raidtracker.configWindow:GetVisible() == true then
		_raidtracker.configWindow:SetVisible(false)
		for i,frame in pairs(_raidtracker.baseFrame) do
			frame:SetVisible(false)
		end
	else
		_raidtracker.configWindow:SetVisible(true)
		for i,frame in pairs(_raidtracker.baseFrame) do
			frame:SetVisible(true)
		end
	end
end

function _raidtracker.show_raidtracker_baseFrames()
	if _raidtracker.baseFrame[1]:GetVisible() == false then
		for i,frame in pairs(_raidtracker.baseFrame) do
			frame:SetVisible(true)
		end
	else
		for i,frame in pairs(_raidtracker.baseFrame) do
			frame:SetVisible(false)
		end
	end
end

function _raidtracker.getBuffExpire(abilityId)
	if _raidtracker.abilities.buff[abilityId] ~= nil then
		if _raidtracker.buff.tracking[_raidtracker.abilities.buff[abilityId]] ~= nil then
			if _raidtracker.buff.tracking[_raidtracker.abilities.buff[abilityId]].duration ~= nil then
				return _raidtracker.buff.tracking[_raidtracker.abilities.buff[abilityId]].duration
			end
		end
	end
	return nil
end

function _raidtracker.getAbilityCooldown(abilityId)
	if _raidtracker.abilities.buff[abilityId] ~= nil then
		if _raidtracker.buff.tracking[_raidtracker.abilities.buff[abilityId]] ~= nil then
			if _raidtracker.buff.tracking[_raidtracker.abilities.buff[abilityId]].cooldown ~= nil then
				return _raidtracker.buff.tracking[_raidtracker.abilities.buff[abilityId]].cooldown
			end
		end
	end
	return nil
end


function _raidtracker.abilityExists(pid, aid)
	if _raidtracker.abilities.registered[pid] ~= nil then
		if _raidtracker.abilities.registered[pid][aid] ~= nil then
			return true
		end
	end
	return false
end

_raidtracker.Player = {}
_raidtracker.Ability = {}

_raidtracker.raid = {}
_raidtracker.raidLastKnownSlotById = {}

function _raidtracker.isInRaid(id)
	for _,v in pairs(_raidtracker.raid) do
		if v == id then
			return true
		end
	end
	return false
end

function _raidtracker.updateRaidStatus()
	_raidtracker.raidNewPlayer = {}
	_raidtracker.raidLeavingPlayer = {}
	local joined = {}
	local left = {}
	local tmpRaid = {}
	for k,v in pairs(_raidtracker.raid) do
		tmpRaid[k] = {id = v, ok = false}
	end
	-- cycle through known units
	for k,v in pairs(Inspect.Unit.List()) do
		-- if it is a group unut
		if string.sub(v, 1, -3) == "group" then
			if tmpRaid[v] ~= nil then
				tmpRaid[v].ok = true
			end
			-- if the group unit id different from the last know id for this group slot, there's  change ! (no shit sherlock	)
			if _raidtracker.raid[v] == nil or _raidtracker.raid[v] ~= k then
				-- just changing position
				if _raidtracker.raidLastKnownSlotById[k] ~= nil then
					_raidtracker.raid[v] = k
				-- Joining the raid
				else
					table.insert(joined, k)
				end
			end
			_raidtracker.raidLastKnownSlotById[k] = v
		end
	end

	-- looking at what was found in the last Unit.List iteration
	for k,v in pairs(tmpRaid) do
		-- if it's not found, then the player left the raid
		if v.ok == false then
			table.insert(left, v.id)
			_raidtracker.raid[k] = nil
			_raidtracker.raidLastKnownSlotById[v.id] = nil
		end
	end


	_raidtracker.RaidLeave(left)
	_raidtracker.RaidJoin(joined)
end

function _raidtracker.getOrCreatePlayer(id)
	local p = _raidtracker.playersById[id]
	if p == nil then

	end
end

function _raidtracker.Player:new(id)
	assert(_raidtracker.playersById[id] ~= nil, "Player ( id : " ..tostring(id) .. " ) already exists.")
	local o = {name = nil, id = id, abilities = {}}
	setmetatable(o, self)
	self.__idex = self
	local tmpU = assert(Inspect.Unit.Detail(id), "unknown user ( id : " .. tostring(id) .. " )")
	o.name = tmpU.name
	_raidtracker.players[name] = o
	_raidtracker.playersById[id] = o
	return o
end

function _raidtracker.Player:isPlayer()
	return self.id == _raidtracker.playerId
	end

function _raidtracker.Player:registerAbility(ability)
	assert(self.abilities[ability.id] ~= nil, "Shouldn't try to register new ability. Update it instead.")
	self.abilities[ability.id] = ability
end

function _raidtracker.Ability:new(player, id)
	local o = {
		player = player, 
		id = id,
		icon = nil,
		name = nil,
		cooldown = nil,
		uses = {},
		lastUse = nil,
	}
	setmetatable(o, self)
	self.__idex = self
	local ab = assert(Inspect.Ability.New.Detail(id), "Unknow ability '" .. tostring(id) .. "'")
	o.icon = ab.icon
	o.name = ab.name
	o.cooldown = ab.cooldown
	if player:isPlayer() then
		table.insert(o.uses, ab.coo)
	end
	player:registerAbility(o)
	return o
end

function _raidtracker.Ability:updateFromMessage(...)
end

function _raidtracker.Ability:updateFromBuff(...)
	self:use{duration = arg.duration}
end

function _raidtracker.Ability:use(...)
	self.lastUse = now
	table.insert(self.use, now)
	self.duration = arg.duration
end

function _raidtracker.isReady()
	return not self:isOnCooldown()
end

function _raidtracker.isOnCooldown()
	if self.lastUse == nil then return false end
	assert(self.cooldown, "No known cooldown for ability id : " .. self.id)
	return self.lastUse + self.cooldown > now
end

function _raidtracker.isRunning()
	-- never been used before
	if self.lastUse == nil or self.duration == nil then return false end
	return self.duration + self.lastUse < now
end



function _raidtracker.registerAbility(playerId, abilityId, abilityType, cooldown, useTime, buffExpire)

	--if _raidtracker.units[playerId] == nil then
	--	local tempUnit = Inspect.Unit.Detail(playerId)
	--	_raidtracker.units[playerId] = tempUnit.name
	--end
	if playerId == nil then return end

	if _raidtracker.abilities.registered[playerId] == nil then
		_raidtracker.abilities.registered[playerId] = {}
		needUpdate = true
	end
	if _raidtracker.abilities.definition[abilityId] ~= nil and _raidtracker.abilities.definition[abilityId] ~= true then
		if _raidtracker.abilities.definition[abilityId].duration ~= nil then 
			buffExpire = _raidtracker.abilities.definition[abilityId].duration
		end
	end

	cooldown = cooldown or _raidtracker.getAbilityCooldown(abilityId)

	-- first registering the ability
	if _raidtracker.abilities.registered[playerId][abilityId] == nil then
		_raidtracker.abilities.registered[playerId][abilityId] = {
			abilityType = abilityType, 
			cooldown = cooldown, 
			useTime = useTime, 
			category = abilityType,
			frame = nil,
			buffExpire = buffExpire,
			lastUseTime = useTime,
			lastUpdate = now,
		}
	--updating
	else
		local rec = _raidtracker.abilities.registered[playerId][abilityId]
		_raidtracker.abilities.registered[playerId][abilityId].lastUpdate = now
		-- first time seeing a buffExpire, the ability is now active.
		if rec.buffExpire == nil then
			-- if the parameter was passed, then the ability is active for buffExpire
			if buffExpire ~= nil then
				_raidtracker.abilities.registered[playerId][abilityId].buffExpire = buffExpire
				-- if it was already used, shouldn't be happening ever.
				if rec.useTime ~= nil then
					-- the buff should be expired, remove it ?
					if buffExpire + rec.useTime > now then
						_raidtracker.unregisterAbility(playerId, abilityId)
						return
					end
				end
			end
			--updating ?
		else
			if rec.useTime ~= nil then
				if _raidtracker.abilities.definition[abilityId] ~= nil and _raidtracker.abilities.definition[abilityId] ~= true then
					if _raidtracker.abilities.definition[abilityId].duration ~= nil then
						if (now - rec.useTime) < _raidtracker.abilities.definition[abilityId].duration then 
							return 
						end
					end
				end
			end
		end

		if rec.lastUseTime ~= nil and useTime ~= nil then
			if _raidtracker.abilities.registered[playerId][abilityId].lastUseTime + 1 > useTime then
				return
			end
		end
		_raidtracker.abilities.registered[playerId][abilityId].useTime = useTime
		_raidtracker.abilities.registered[playerId][abilityId].lastUseTime = useTime
	end
end

function _raidtracker.unregisterAbility(playerId, abilityId)
	if _raidtracker.abilities.registered[playerId] == nil then
		return
	end

	if _raidtracker.abilities.registered[playerId][abilityId] ~= nil then
		local data = _raidtracker.abilities.registered[playerId][abilityId]
		if data.frame ~= nil then
			data.frame.used.playerId = nil
			data.frame.used.abilityId = nil
			data.frame:SetVisible(false)
		end
		_raidtracker.abilities.registered[playerId][abilityId] = nil
		needUpdate = true
	end
end

function _raidtracker.cleanAbilities(playerId)
	if _raidtracker.abilities.registered[playerId] ~= nil then
		for abilityId, data in pairs(_raidtracker.abilities.registered[playerId]) do
			_raidtracker.unregisterAbility(playerId, abilityId)
		end
		_raidtracker.abilities.registered[playerId] = nil
	end
end


function _raidtracker.onLoad(e, addon)
	if addon == "RaidTracker" then
		_raidtracker.init()
		lastFrameTime = Inspect.Time.Real()
	end
end

function _raidtracker.ShowHideCategory(e, categoryName, frame)
	local tmp = _raidtracker.categoriesOptions[categoryName]
	if tmp == false then
		_raidtracker.categoriesOptions[categoryName] = true 
		frame:SetBackgroundColor(unpack(_raidtracker_color.category.active.background))
		--frame.text:SetText("")
		--frame:SetHeight(10)
	else
		_raidtracker.categoriesOptions[categoryName] = false 
		frame:SetBackgroundColor(unpack(_raidtracker_color.category.inactive.background))
		--frame.text:SetText(_raidtracker.translate(categoryName))
		--frame:SetHeight(15)
	end
	needUpdate = true
end

function _raidtracker.showHideAllCategories()
	for category, frame in pairs(_raidtracker.frames.categories) do
		_raidtracker.ShowHideCategory(nil, category, frame)
	end
end

function _raidtracker.setupIcon()
	local f = UI.CreateFrame("Frame", "icon frame", _raidtracker.context)
	f:SetLayer(1)
	f:EventAttach(Event.UI.Input.Mouse.Left.Click, _raidtracker.showConfig, "show config")
	f:EventAttach(Event.UI.Input.Mouse.Right.Click, _raidtracker.show_raidtracker_baseFrames, "show base frames")
	f:EventAttach(Event.UI.Input.Mouse.Middle.Click, _raidtracker.showHideAllCategories, "show base frames")
	Library.LibDrag.draggify(f, function(f, x, y) _raidtracker_baseFrames.icon = {x=x,y=y} end)
	f:SetWidth(50)
	f:SetHeight(50)
	f.texture = UI.CreateFrame("Texture", "texture", f)
	f.texture:SetLayer(0)
	f.texture:SetTexture("Rift", "medal_gold.png.dds")
	f.texture:SetPoint("TOPLEFT", f, "TOPLEFT")
	f.texture:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT")

	if _raidtracker_baseFrames.icon == nil then
		_raidtracker_baseFrames.icon = {x = 1000, y = 500}
	end

	f:SetPoint("TOPLEFT", UIParent, "TOPLEFT", _raidtracker_baseFrames.icon.x, _raidtracker_baseFrames.icon.y)
	_raidtracker.iconFrame = f
end

function _raidtracker.init()

	_raidtracker.RaidJoin, _raidtracker.RaidJoinHandle = Utility.Event.Create("RaidTracker", "Raid.Join")
	_raidtracker.RaidLeave, _raidtracker.RaidLeaveHandle = Utility.Event.Create("RaidTracker", "Raid.Leave")
	if _raidtracker_positions == nil then
		_raidtracker_positions = {}
		if _raidtracker_positions.base == nil then
			_raidtracker_positions.base = {x = 960, y = 540}
		end
	end

	if _raidtracker_tracking == nil then 
		_raidtracker_tracking = {} 
		_raidtracker_tracking["abilities"] = {}
		_raidtracker_tracking["categories"] = {}
	end

	if colors == nil or _raidtracker_color.ability.dead == nil then
		colors = _raidtracker.default.colors
	end

	if _raidtracker_baseFrames == nil then
		_raidtracker_baseFrames = {}
		_raidtracker_baseFrames.count = 1
	end

	if _raidtracker_baseFrames.width == nil then _raidtracker_baseFrames.width = 200 end
	if _raidtracker_baseFrames.fontSize == nil then _raidtracker_baseFrames.fontSize = 15 end
	if _raidtracker_baseFrames.frames == nil then 
		_raidtracker_baseFrames.frames = {} 
		for i=1,5,1 do
			_raidtracker_baseFrames.frames[i] = {x = 200 + i * 200, y = 500}
		end
	end

	if _raidtracker_baseFrames.categories == nil then
		_raidtracker_baseFrames.categories = {}
		for ab, category in pairs(_raidtracker.abilities.tracking) do
			if _raidtracker_baseFrames.categories[category] == nil then
				_raidtracker_baseFrames.categories[category] = 1
			end
		end
	end
	if _raidtracker_color == nil then
		_raidtracker_color = {}
	end
	for k,v in pairs(_raidtracker.default.colors) do
		if _raidtracker_color[k] == nil then
			_raidtracker_color[k] = v
		else
			for kk,vv in pairs(v) do
				if _raidtracker_color[k][kk] == nil then
					_raidtracker_color[k][kk] = vv
				end
			end
		end
	end

	if _raidtracker_uiScale == nil then _raidtracker_uiScale = 1 end
	for i=1,_raidtracker_baseFrames.count,1 do
		_raidtracker.setupBaseFrame(i)
	end

	_raidtracker.setupIcon()
	Command.Message.Accept("raid", "RATR_AU") -- Ability Use Notification / abilityId,cooldown
	Command.Message.Accept("raid", "RATR_UR") -- Update Response / abilityId,cooldown,currentCooldown;abilityId,cooldown,currentCooldown
	Command.Message.Accept("raid", "RATR_UR2")
	Command.Message.Accept("raid", "RATR_UR3")
	Command.Message.Accept("raid", "RATR_UQ") -- Update Query ?types,type2,type3...
	Command.Message.Accept("party", "RATR_AU") -- Ability Use Notification / abilityId,cooldown
	Command.Message.Accept("party", "RATR_UR") -- Update Response / abilityId,cooldown,currentCooldown;abilityId,cooldown,currentCooldown
	Command.Message.Accept("party", "RATR_UR2")
	Command.Message.Accept("party", "RATR_UR3")
	Command.Message.Accept("party", "RATR_UQ") -- Update Query ?types,type2,type3...
	_raidtracker.BroadcastUpdateQuery()


end

function _raidtracker.createCategoryFrame(category)
	local frame = UI.CreateFrame("Frame", "category frame", _raidtracker.context)
	frame:SetWidth((_raidtracker_baseFrames.width - 2) * _raidtracker_uiScale)
	frame:SetHeight(15 * _raidtracker_uiScale)
	frame:SetLayer(5)
	frame.categoryName = category
	frame:SetBackgroundColor(unpack(_raidtracker_color.category.active.background))
	frame.text = UI.CreateFrame("Text", "category frame text", frame)
	frame.text:SetFontSize(_raidtracker_baseFrames.fontSize)
	frame.text:SetFontColor(1,1,1)
	frame.text:SetText(_raidtracker.translate(category))
	
	if _raidtracker_tracking["categories"][category] == nil then 
		_raidtracker_tracking["categories"][category] = true
	end

	frame.text:SetPoint("CENTER", frame, "CENTER")
	frame:EventAttach(Event.UI.Input.Mouse.Right.Click, 
		function(e) _raidtracker.ShowHideCategory(e, frame.categoryName, frame) end, 
		AddonName .. "ShowHide" .. category)
	local glow = {}
	glow.colorR = 0
	glow.colorG = 0
	glow.colorB = 0
	glow.strength = 1
	frame.text:SetEffectGlow(glow)
	_raidtracker.frames.categories[category] = frame
end

function _raidtracker.setupCategoriesFrames()
	for ab, category in pairs(_raidtracker.abilities.tracking) do
		if _raidtracker.frames.categories[category] == nil then
			_raidtracker.createCategoryFrame(category)
		end
	end
end

function _raidtracker.increase_raidtracker_uiScale()
	_raidtracker.rescale(true)
end

function _raidtracker.decrease_raidtracker_uiScale()
	_raidtracker.rescale(false)
end

function _raidtracker.resclaeElement(element, uiSclae, lastScale)
	if element:GetType() == "Text" then
		element:SetFontSize(element:GetFontSize() / lastScale * _raidtracker_uiScale)
	else
		element:SetWidth(element:GetWidth() / lastScale * _raidtracker_uiScale)
		element:SetHeight(element:GetHeight() / lastScale * _raidtracker_uiScale)
	end
end


function _raidtracker.rescale(upScale)
	lastScale = _raidtracker_uiScale
	if upScale then
		_raidtracker_uiScale = _raidtracker_uiScale + 0.05
	else
		_raidtracker_uiScale = _raidtracker_uiScale - 0.05
	end
	for category, frame in pairs(_raidtracker.frames.categories) do
		_raidtracker.resclaeElement(frame, _raidtracker_uiScale, lastScale)
	end
	for f, frame in pairs(_raidtracker.frames.abilities) do
		_raidtracker.resclaeElement(frame, _raidtracker_uiScale, lastScale)
		_raidtracker.resclaeElement(frame.icon, _raidtracker_uiScale, lastScale)
		_raidtracker.resclaeElement(frame.cdBar, _raidtracker_uiScale, lastScale)
		_raidtracker.resclaeElement(frame.cdText, _raidtracker_uiScale, lastScale)
		_raidtracker.resclaeElement(frame.player, _raidtracker_uiScale, lastScale)
		_raidtracker.resclaeElement(frame.texture, _raidtracker_uiScale, lastScale)
	end

	for i=1,_raidtracker_baseFrames.count,1 do
		_raidtracker.resclaeElement(_raidtracker.baseFrame[i], _raidtracker_uiScale, lastScale)
		_raidtracker.resclaeElement(_raidtracker.baseFrame[i].text, _raidtracker_uiScale, lastScale)
	end
	needUpdate = true
end


function _raidtracker.setupBaseFrame(i)
	if _raidtracker.context == nil then
		_raidtracker.context = UI.CreateContext("RaidTracker")
	end
	_raidtracker.baseFrame[i] = UI.CreateFrame("Frame", "baseFrame", _raidtracker.context)
	Library.LibDrag.draggify(_raidtracker.baseFrame[i], function(f, x, y) _raidtracker_baseFrames.frames[i] = {x=x,y=y} end)
	local f = _raidtracker.baseFrame[i]
	f.id = i
	f:SetBackgroundColor(0.07,0.07,0.07,0.5)
	f:SetWidth(_raidtracker_baseFrames.width * _raidtracker_uiScale)
	f:SetHeight(30 * _raidtracker_uiScale)
	f:EventAttach(Event.UI.Input.Mouse.Right.Click, _raidtracker.showConfig, "show config")
	f:EventAttach(Event.UI.Input.Mouse.Wheel.Forward, _raidtracker.increase_raidtracker_uiScale, "show config")
	f:EventAttach(Event.UI.Input.Mouse.Wheel.Back, _raidtracker.decrease_raidtracker_uiScale, "show config")
	if _raidtracker_baseFrames.frames[i] == nil then
		_raidtracker_baseFrames.frames[i] = {x = 200 + i * 200, y = 500}
	end
	f:SetPoint("TOPLEFT", UIParent, "TOPLEFT", _raidtracker_baseFrames.frames[i].x, _raidtracker_baseFrames.frames[i].y)

	f.text = UI.CreateFrame("Text", "text", f)
	f.text:SetText("Raid Tracker (" .. i .. ")")
	f.text:SetFontSize(_raidtracker_baseFrames.fontSize * _raidtracker_uiScale)
	f.text:SetLayer(5)
	f.text:SetPoint("TOPCENTER", f, "TOPCENTER", 0, 5)

	_raidtracker.setupCategoriesFrames()
	f:SetVisible(false)

end


function _raidtracker.createAbilityFrame()
	local glow = {}
	glow.colorR = 0
	glow.colorG = 0
	glow.colorB = 0
	glow.strength = 2

	local f = UI.CreateFrame("Frame", "ability frame", _raidtracker.context)
	f:SetHeight(25 * _raidtracker_uiScale)
	f:SetWidth(_raidtracker_baseFrames.width * _raidtracker_uiScale)
	f.icon = UI.CreateFrame("Texture", "ability texture", f)
	f.icon:SetPoint("TOPLEFT", f, "TOPLEFT", 1, 1)
	f.icon:SetWidth(23 * _raidtracker_uiScale)
	f.icon:SetHeight(23 * _raidtracker_uiScale)
	f.player = UI.CreateFrame("Text", "ability player name", f)
	f.player:SetPoint("TOPLEFT", f.icon, "TOPRIGHT", 2, 0)
	f.player:SetFontSize(_raidtracker_baseFrames.fontSize * _raidtracker_uiScale)
	f.player:SetLayer(3)
	f.player:SetEffectGlow(glow)
	f.cdText = UI.CreateFrame("Text", "ability cooldown text", f)
	f.cdText:SetPoint("TOPRIGHT", f, "TOPRIGHT", -5 * _raidtracker_uiScale, 1)
	f.cdText:SetFontSize(_raidtracker_baseFrames.fontSize * _raidtracker_uiScale)
	f.cdText:SetLayer(3)
	f.cdText:SetEffectGlow(glow)
	f.cdBar = UI.CreateFrame("Frame", "ability cooldown bar", f)
	f.cdBar:SetPoint("TOPLEFT", f.icon, "TOPRIGHT", 1, 0)
	f.cdBar:SetHeight(23 * _raidtracker_uiScale)
	f.cdBar:SetLayer(2)
	f.used = {playerId = nil, abilityId = nil}
	f:SetVisible(false)

	f.texture = UI.CreateFrame("Texture", "texture", f)
	f.texture:SetTexture("RaidTracker", "img/BarSkin.png")
	f.texture:SetWidth((_raidtracker_baseFrames.width - 27) * _raidtracker_uiScale)
	f.texture:SetHeight(23 * _raidtracker_uiScale)
	f.texture:SetPoint("BOTTOMLEFT", f.icon, "BOTTOMRIGHT", 1, 0)
	f:SetLayer(9)

	_raidtracker.frames.abilities[f] = f

	f:SetVisible(false)
	return f
end

function _raidtracker.getUnitName(playerId)
	if _raidtracker.units[playerId] == nil then
		local tempUnit = Inspect.Unit.Detail(playerId)
		_raidtracker.units[playerId] = tempUnit.name
	end
	return _raidtracker.units[playerId]
end

function _raidtracker.getAbilityFrame(playerId, abilityId)
	local found = false
	local searchMod = "specific"
	if playerId == nil and abilityId == nil then
		 searchMod = "free"
	end
	for k, frame in pairs(_raidtracker.frames.abilities) do
		if searchMod == "specific" and playerId == frame.used.playerId and abilityId == frame.used.abilityId then
			return frame
		elseif searchMod == "free" then
			if frame.used.playerId == nil then
				return frame
			end
		end
	end
	if searchMod == "specific" then 
		return _raidtracker.getAbilityFrame()
	end
	return _raidtracker.createAbilityFrame()
end

function _raidtracker.updateFrameCD(frame, data)

	if data == nil then
		data = _raidtracker.abilities.registered[frame.used.playerId][frame.used.abilityId]
	end

	if frame == nil then return end

	if data.lastUpdate + 300 < now then
		_raidtracker.unregisterAbility(frame.used.playerId, frame.used.abilityId)
	end

	if data.buffExpire ~= nil and data.useTime ~= nil then
		if data.useTime > now then
			return
		end
		frame.cdText:SetText(_raidtracker.round(data.useTime + data.buffExpire - now, 1) .. "s")
		frame.cdBar:SetBackgroundColor(unpack(_raidtracker_color.ability.active.background))
		local remaining = data.useTime + data.buffExpire - now
		local width = remaining / data.buffExpire * (_raidtracker_baseFrames.width - 27) * _raidtracker_uiScale
		if width > (_raidtracker_baseFrames.width - 27) * _raidtracker_uiScale then
			width = (_raidtracker_baseFrames.width - 27) * _raidtracker_uiScale
		end
		frame.cdBar:SetWidth(width)
		if (data.useTime + data.buffExpire - now) <= 0.1 then 
			data.buffExpire = nil 
		end
		data.lastState = "active"
	elseif (data.useTime == nil and (data.lastState ~= "ready" or needUpdate)) or (data.useTime ~= nil and data.useTime > now) then
		frame.cdText:SetText("Ready !")
		frame.cdBar:SetWidth((_raidtracker_baseFrames.width - 27) * _raidtracker_uiScale)
		if _raidtracker.isCasterAlive(data.playerId) then
			frame.cdBar:SetBackgroundColor(unpack(_raidtracker_color.ability.ready.background))
		else
			frame.cdBar:SetBackgroundColor(unpack(_raidtracker_color.ability.dead.background))
		end
		data.lastState = "ready"
	elseif data.useTime ~= nil then
		local remaining = now - data.useTime
		local width = remaining / data.cooldown * (_raidtracker_baseFrames.width - 27) * _raidtracker_uiScale
		if (remaining / data.cooldown) > 1 then
			width = (_raidtracker_baseFrames.width - 27) * _raidtracker_uiScale
		end
		if width ~= frame.lastWidth or needUpdate then
			if remaining > 10 then	
				frame.cdText:SetText(tostring(math.floor(data.cooldown - remaining, 1)) .. "s")
			else
				frame.cdText:SetText(tostring(_raidtracker.round(data.cooldown - remaining, 1)) .. "s")
			end
			if width > (_raidtracker_baseFrames.width - 27) * _raidtracker_uiScale then
				width = (_raidtracker_baseFrames.width - 27) * _raidtracker_uiScale
			end
			frame.cdBar:SetWidth(width)
			if _raidtracker.isCasterAlive(data.playerId) then
				frame.cdBar:SetBackgroundColor(unpack(_raidtracker_color.ability.cooldown.background))
			else
				frame.cdBar:SetBackgroundColor(unpack(_raidtracker_color.ability.dead.background))
			end
		end
		frame.lastWidth = width
		data.lastState = "cooldown"
	end
	if data.useTime ~= nil and data.cooldown ~= nil and data.useTime + data.cooldown < now then
		data.useTime = nil
	end
	if _raidtracker.isCasterAlive(data.playerId) ~= _raidtracker.wasCasterAlive(data.playerId) or needUpdate == true  then
		if _raidtracker.isCasterAlive(frame.used.playerId) then
			if data.useTime == nil then
				frame.cdBar:SetBackgroundColor(unpack(_raidtracker_color.ability.ready.background))
			else
				frame.cdBar:SetBackgroundColor(unpack(_raidtracker_color.ability.cooldown.background))
			end
		else
			frame.cdBar:SetBackgroundColor(unpack(_raidtracker_color.ability.dead.background))
		end
	end
end

function _raidtracker.updateFrames(i)
	local lastFrame = _raidtracker.baseFrame[i]
	local ll = lastFrame
	local cnt = 0
	local categories = {}
	local showCategory = nil
	local cntCat = 0
	local ab = nil
	local cntCatShown = 0
	local tmpShow = nil
	local players = Inspect.Unit.Lookup({"group01","group02","group03","group04","group05","group06","group07","group08","group09","group10","group11","group12","group13","group14","group15","group16","group17","group18","group19","group20",})
	for id,unit in pairs(Inspect.Unit.Detail(players)) do
		if unit ~= nil then
			if playerStatus[id] == nil then
				playerStatus[id] = {}
				playerStatus[id].alive = unit.health == 0
				playerStatus[id].aliveBefore = unit.health == 0
				if _raidtracker.abilities.registered[unit.name] ~= nil then
					for k,ab in pairs(_raidtracker.abilities.registered[unit.name]) do
						ab.casterAlive = unit.health == 0
						ab.casterAlive = unit.health ~= 0
					end
				end
			else
				playerStatus[id].alive = unit.health == 0
			end
			if playerStatus[id].alive ~= playerStatus[id].aliveBefore then
				if _raidtracker.abilities.registered[unit.name] ~= nil then
					for k,ab in pairs(_raidtracker.abilities.registered[unit.name]) do
						ab.casterAlive = unit.health == 0
						ab.casterAlive = unit.health ~= 0
					end
				end
				playerStatus[id].aliveBefore = unit.health == 0
			end
		end
	end
	if needUpdate then
		--print("need update")
		for category,categoryFrame in pairs(_raidtracker.frames.categories) do
			if _raidtracker_baseFrames.categories[category] == i then
				if _raidtracker_tracking['categories'][category] == true then
					if _raidtracker.categoriesOptions[category] == nil then
						showCategory = true
						categoryFrame:SetBackgroundColor(unpack(_raidtracker_color.category.active.background))
					else
						showCategory = _raidtracker.categoriesOptions[category]
						if showCategory then
							categoryFrame:SetBackgroundColor(unpack(_raidtracker_color.category.active.background))
						else
							categoryFrame:SetBackgroundColor(unpack(_raidtracker_color.category.inactive.background))
						end
					end
					if categoryFrame ~= lastFrame then
						cntCatShown = cntCatShown + 1
						if _raidtracker_baseFrames.direction == "top" then
							categoryFrame:ClearPoint("TOPLEFT")
							categoryFrame:SetPoint("BOTTOMLEFT", lastFrame, "TOPLEFT", 0, 0)
						else
							categoryFrame:ClearPoint("BOTTOMLEFT")
							categoryFrame:SetPoint("TOPLEFT", lastFrame, "BOTTOMLEFT", 0, 0)
						end
						lastFrame = categoryFrame
					end
					cntCat = 0
					for playerId, abilities in pairs(_raidtracker.abilities.registered) do
						for ability, data in pairs(abilities) do
							if (data.category == category) and _raidtracker_tracking['abilities'][ability] ~= false then
								cntCat = cntCat + 1
								if data.frame == nil then
									local f = _raidtracker.getAbilityFrame()
									f.used.playerId = playerId
									f.used.abilityId = ability
									ab = Inspect.Ability.New.Detail(ability)
									if ab ~= nil then
										f.icon:SetTexture("Rift", ab.icon)
									end
									f.player:SetText(f.used.playerId)
									data.frame = f
								end
								if lastFrame ~= data.frame then
									if _raidtracker_baseFrames.direction == "top" then
										data.frame:ClearPoint("TOPLEFT")
										data.frame:SetPoint("BOTTOMLEFT", lastFrame, "TOPLEFT", 0, 0)
									else
										data.frame:ClearPoint("BOTTOMLEFT")
										data.frame:SetPoint("TOPLEFT", lastFrame, "BOTTOMLEFT", 0, 0)
									end
								end
								if showCategory ~= data.frame:GetVisible() then
									data.frame:SetVisible(true)
								end
								if data.frame.lastVisible ~= showCategory then
									data.frame.lastVisible = showCategory
									data.frame:SetVisible(showCategory)
								end
								_raidtracker.updateFrameCD(data.frame, data)
								if showCategory == true then
									lastFrame = data.frame
									cnt = cnt + 1
								end
							end
						end
					end
				else
					for playerId, abilities in pairs(_raidtracker.abilities.registered) do
						for ability, data in pairs(abilities) do
							if data.category == category then
								if frame ~= nil then
									data.frame.lastVisible = data.frame:GetVisible()
									data.frame:SetVisible(false)
								end
							end
						end
					end
				end
				if cntCat == 0 then
					if categoryFrame ~= lastFrame then
						cntCatShown = cntCatShown - 0.2
					end
					categoryFrame:SetVisible(false)
					lastFrame = ll
				else
					categoryFrame:SetVisible(true)
				end
				ll = lastFrame
			end
		end
	else
		for playerId, abilities in pairs(_raidtracker.abilities.registered) do
			for ability, data in pairs(abilities) do
				_raidtracker.updateFrameCD(data.frame, data)
			end
		end
	end
	--_raidtracker.baseFrame:SetHeight((30 * _raidtracker_uiScale) + (25 * _raidtracker_uiScale) * cnt + cnt + cntCatShown * (5 * _raidtracker_uiScale))
end

function _raidtracker.OnNewAbilities(e, abs)
	if _raidtracker.playerName == nil then
		return
	end
	_raidtracker.UpdatePlayerAbilities()
end

function _raidtracker.onUnitAvailable(e, units)
	local player = Inspect.Unit.Detail('player')
	_raidtracker.playerId = player.id
	_raidtracker.playerName = player.name
	f = false
	for k,v in pairs(units) do 
		if k == _raidtracker.playerId then
			f = true
		end
	end
	if f == false then return end
	_raidtracker.UpdatePlayerAbilities()
end

function _raidtracker.UpdatePlayerAbilities(abs)
	if _raidtracker.playerName == nil then
		return
	end
	--_raidtracker.cleanAbilities(_raidtracker.playerId)
	if abs == nil then
		abs = Inspect.Ability.New.List()
	end
	if abs == nil then return end

	local first = true
	tmpAbs[_raidtracker.playerName] = {}
	if _raidtracker.abilities.registered[_raidtracker.playerName] ~= nil then
		first = false
	end
	for k,ab in pairs(abs) do
		if _raidtracker.abilities.tracking[k] ~= nil then
			tmpAbs[_raidtracker.playerName][k] = k
			local t = Inspect.Ability.New.Detail(k)
			if t.currentCooldownRemaining ~= nil then
				-- on cd
				_raidtracker.registerAbility(_raidtracker.playerName, k, _raidtracker.abilities.tracking[k], math.floor(t.cooldown), math.floor(now - t.cooldown + t.currentCooldownRemaining))
			else
				-- not on CD
				_raidtracker.registerAbility(_raidtracker.playerName, k, _raidtracker.abilities.tracking[k], math.floor(t.cooldown))
			end
		end
	end
	if first ~= true then
		for k,ab in pairs(_raidtracker.abilities.registered[_raidtracker.playerName]) do
			if tmpAbs[_raidtracker.playerName][k] == nil then
				_raidtracker.unregisterAbility(_raidtracker.playerName, k)
				if ab.frame ~= nil then
					ab.frame.used.playerId = nil
					ab.frame = nil
				end
		 	end
		end
	end
	_raidtracker.BroadcastStatus()
	needUpdate = true
end

function _raidtracker.MessageCallback(code, msg)
	if code == nil then return end
	--print(tostring(code))
	--print(msg)
end	

function _raidtracker.OnAbilityUse(e, data)
	for abilityId, cd in pairs(data) do 
		if cd > 2 then
			--print(abilityId)
			if _raidtracker.abilities.tracking[abilityId] then
				if _raidtracker.abilities.registered[_raidtracker.playerName] ~= nil and _raidtracker.abilities.registered[_raidtracker.playerName][abilityId] ~= nil then
					local castbar = Inspect.Unit.Castbar('player')
					local castTime = 0
					local cooldown = _raidtracker.abilities.registered[_raidtracker.playerName][abilityId].cooldown
					if castbar ~= nil then
						castTime = _raidtracker.round(castbar.duration,1)
						cooldown = cooldown - castTime
					end
					_raidtracker.abilities.registered[_raidtracker.playerName][abilityId].useTime = now + castTime
					_raidtracker.abilities.registered[_raidtracker.playerName][abilityId].buffExpire = _raidtracker.getBuffExpire(abilityId)
					response = tostring(abilityId) .. "," .. tostring(cooldown)
					if _raidtracker.GetBroadcastType() ~= nil then
						Command.Message.Broadcast(_raidtracker.GetBroadcastType(), nil, "RATR_AU", response, _raidtracker.MessageCallback)
					end
					return
				end
			end
		end
	end
end

function _raidtracker.BroadcastStatus()
	local response = ""
	_raidtracker.lastUpdate = now
	if _raidtracker.abilities.registered[_raidtracker.playerName] == nil or next(_raidtracker.abilities.registered[_raidtracker.playerName]) == nil then
		return
	end
	local cnt = 0
	local msgCnt = 0
	local title = nil
	for aid,adata in pairs(_raidtracker.abilities.registered[_raidtracker.playerName]) do
		cnt = cnt + 1
		if string.len(response) == 0 then
			response = tostring(aid) .. ","  .. tostring(adata.cooldown)
		else
			response = response .. ";" .. tostring(aid) .. ","  .. tostring(adata.cooldown)
		end
		if adata.useTime ~= nil then
			response = response .. "," .. tostring(_raidtracker.round(now - adata.useTime, 2))
		end

		if cnt > 5 then
			if _raidtracker.GetBroadcastType() ~= nil then
				if msgCnt == 0 then
					title = "RATR_UR"
				else
					title = "RATR_UR2"
				end
				Command.Message.Broadcast(_raidtracker.GetBroadcastType(), nil, title, tostring(response), _raidtracker.MessageCallback)
				response = ""
				msgCnt = msgCnt + 1 
			end
		end
	end

	if _raidtracker.GetBroadcastType() ~= nil then
		if msgCnt == 0 then
			title = "RATR_UR"
		else
			title = "RATR_UR2"
		end
		Command.Message.Broadcast(_raidtracker.GetBroadcastType(), nil, title, tostring(response), _raidtracker.MessageCallback)
	end
	if _raidtracker.GetBroadcastType() == nil then return end
	Command.Message.Broadcast(_raidtracker.GetBroadcastType(), nil, "RATR_UR3", "", _raidtracker.MessageCallback)
	_raidtracker.lastUpdate = now
end

function _raidtracker.BroadcastUpdateQuery()
	if _raidtracker.GetBroadcastType() ~= nil then
		if _raidtracker.lastUpdateQuery == nil or _raidtracker.lastUpdateQuery + 30 < now then
			Command.Message.Broadcast(_raidtracker.GetBroadcastType(), nil, "RATR_UQ", "")
			_raidtracker.lastUpdateQuery = now
		end
	end
end


function _raidtracker.OnMessageReceive(e, from, type, channel , id , data)
	--print(from .. " " .. id)
	local ccd = nil
	--print("(" .. from .. ") #" .. id .. ": " .. data)
	--print(tostring("[" .. type .. "] " .. from) .. " ("..id..") |" .. tostring(channel) .. "| " .. tostring(data))
	if type == "raid" or type == "party" then
		--printf("%s from %s", id, from)
		if from == _raidtracker.playerName then
			return
		end
		--local tempUnit = Inspect.Unit.Detail(from)
		if id == "RATR_UQ" then
			-- send status of current abilitie
			if _raidtracker.lastUpdate ~= nil and _raidtracker.lastUpdate + 15 > now then
				return
			end
			_raidtracker.BroadcastStatus()
		elseif id == "RATR_UR3" then
			local rmv = 0
			if _raidtracker.abilities.registered[from] == nil then return end
			for k,v in pairs(_raidtracker.abilities.registered[from]) do
				if tmpAbs[from] ~= nil and tmpAbs[from][k] == nil then
					rmv = rmv + 1
					_raidtracker.unregisterAbility(from, k)
					if v.frame ~= nil then
						v.frame.used.playerId = nil
						v.frame.used.abilityId= nil
						v.frame:SetVisible(false)
					end
				end
			end
			if rmv > 0 then 
				needUpdate = true
			end
			tmpAbs[from] = {}
		elseif id == "RATR_UR" or id == "RATR_UR2" then
			_raidtracker.lastUpdateByPlayerId[from] = now
			msg = _raidtracker.split(data, ";")
			if id == "RATR_UR" then
				--_raidtracker.cleanAbilities(from)
				tmpAbs[from] = {}
			end
			-- register or update ability
			-- abilityId,cooldown,currentCooldown
			for k,abdata in pairs(msg) do
				local tmpData = _raidtracker.split(abdata, ",")
				tmpAbs[from][tmpData[1]] = tmpData[1]
				if tmpData[3] ~= nil then
					ccd = now - tmpData[3]
				else
					ccd = nil
				end
				--receiving update
				_raidtracker.registerAbility(from, tmpData[1], _raidtracker.abilities.tracking[tmpData[1]], tmpData[2], ccd)
			end
		elseif id == "RATR_AU" then
			_raidtracker.lastUpdateByPlayerId[from] = now
			local tmpData = _raidtracker.split(data, ",")
			if from == _raidtracker.playerName then
				return
			end
			-- receiving spell use
			_raidtracker.registerAbility(from, tmpData[1], _raidtracker.abilities.tracking[tmpData[1]], tmpData[2], now, _raidtracker.getBuffExpire(tmpData[1]))
		end
	end
end


function _raidtracker.onUpdate()
	now = Inspect.Time.Real()
	lastFrameTime = lastFrameTime or now
	if lastFrameTime + 0.10 > now then return end
	lastFrameTime = now
	_raidtracker.updateRaidStatus()

	_raidtracker.lastUpdate = _raidtracker.lastUpdate or now
	
	if _raidtracker.lastUpdate == nil or _raidtracker.lastUpdate + 15 < now then
		_raidtracker.BroadcastStatus()
		needUpdate = true
	end

	if _raidtracker.lastPlayerUpdate == nil or _raidtracker.lastPlayerUpdate + 5 < now then
		_raidtracker.UpdatePlayerAbilities()
		_raidtracker.lastPlayerUpdate = now
	end
	for playerId, lastUpdate in pairs(_raidtracker.lastUpdateByPlayerId) do
		if now > lastUpdate + 60 then
			_raidtracker.cleanAbilities(playerId)
		end
	end
	for i, frame in pairs(_raidtracker.baseFrame) do
		_raidtracker.updateFrames(i)
	end
	needUpdate = false

end

function _raidtracker.onBuffAdd(e, unit, buffs)
	local caster
	local ability
	local newBuff = {}
	local buffCfg
	for k,v in pairs(buffs) do
		if _raidtracker.buff.tracking[v] ~= nil then
			newBuff[k] = v
		end
	end
	for k,v in pairs(Inspect.Buff.Detail(unit, newBuff)) do
		caster = Inspect.Unit.Detail(v.caster)
		target = Inspect.Unit.Detail(unit)
		if v.debuff then
			isBuff = "debuff"
		else
			isBuff = "buff"
		end
		if caster ~= nil then
			buffCfg = _raidtracker.buff.tracking[v.type]
			if buffCfg.unit ~= nil and buffCfg.unit == "caster" and caster.id == buffCfg.unit then
				-- buff to track on caster (cause they're applied on the group)
				_raidtracker.registerAbility(caster.name, buffCfg.abilityId, _raidtracker.abilities.tracking[buffCfg.abilityId], buffCfg.cooldown, now, math.ceil(v.remaining))
			elseif buffCfg.unit == nil or buffCfg.unit ~= "caster" then
				-- buff to track on single target
				_raidtracker.registerAbility(caster.name, buffCfg.abilityId, _raidtracker.abilities.tracking[buffCfg.abilityId], buffCfg.cooldown, now, math.ceil(v.remaining))
			end
		end
	end
end

function _raidtracker.onBuffRemove(unit, buffs)
end

function _raidtracker.onCombatHeal(e, data)
	if _raidtracker.abilities.namesToId[data.abilityName] ~= nil then
		local abilityId = _raidtracker.abilities.namesToId[data.abilityName]
		k = Inspect.Ability.New.Detail(abilityId)
		-- battle rez used
		if _raidtracker.abilities.tracking[abilityId] == "battleRes" then
			_raidtracker.registerAbility(data.casterName, abilityId, _raidtracker.abilities.tracking[abilityId], 300, now)
		end
	end
end


Command.Event.Attach(Event.System.Update.Begin, _raidtracker.onUpdate, AddonName.."OnUpdate")
Command.Event.Attach(Event.Addon.Load.End, _raidtracker.onLoad, AddonName.."OnLoad")
Command.Event.Attach(Event.Unit.Availability.Full, _raidtracker.onUnitAvailable, AddonName.."OnUnitAvailable")
Command.Event.Attach(Event.Ability.New.Add, _raidtracker.OnNewAbilities, AddonName.."OnNewAbilities")
Command.Event.Attach(Event.Ability.New.Cooldown.Begin, _raidtracker.OnAbilityUse, AddonName.."OnAbilityUse")
Command.Event.Attach(Event.Message.Receive, _raidtracker.OnMessageReceive, AddonName.."OnMessageReceive")
Command.Event.Attach(Event.Buff.Add, _raidtracker.onBuffAdd, AddonName.."OnBuffAdd")
Command.Event.Attach(Event.Combat.Heal, _raidtracker.onCombatHeal, AddonName.."OnCombatHeal")

Command.Event.Attach(Event.Buff.Remove, _raidtracker.onBuffRemove, AddonName.."OnMessageReceive")


table.insert(Command.Slash.Register("rtcfg"), {_raidtracker.showConfig, "RaidTracker", "showConfig"})